{-# LANGUAGE BangPatterns, NoImplicitPrelude #-}

module UnitFractionsDecomposition2 where

import GHC.Base
import GHC.Num ((+),(-),(*),abs)
import GHC.List (null)
import Data.List (minimumBy)
import GHC.Real (round,fromIntegral,(/),truncate)
import GHC.Float (sqrt)

setOfSolutions :: Double -> [(Double, Double)]
setOfSolutions k 
 | isRangeN k = [(x, x/(k*x - 1)) | x <- [fromIntegral (truncate (1.0 / k)) + 1.0..min (fromIntegral (truncate (2.0 / k))) (fromIntegral (truncate ((sqrt (k*k + 16) - k + 4)/(4*k))))]]
 | otherwise = []
{-# INLINE setOfSolutions #-}

suitable2 :: Double -> (Double,Double)
suitable2 k 
 | null xs = (undefined, undefined)
 | otherwise = minimumBy (\(_, y1) (_, y2) -> compare (abs (y1 - fromIntegral (round y1))) (abs (y2 - fromIntegral (round y2)))) xs
      where !xs = setOfSolutions k
{-# INLINE suitable2 #-}

suitable21 :: Double -> ([Double],Double)
suitable21 k  
 | null xs = ([],undefined)
 | otherwise = let (!a,!b) = minimumBy (\(_, y1) (_, y2) -> compare (abs (y1 - fromIntegral (round y1))) (abs (y2 - fromIntegral (round y2)))) xs
    in ([a,b],k - (1.0/a + 1.0/fromIntegral (round b)))
      where !xs = setOfSolutions k
{-# INLINE suitable21 #-}

isRangeN :: Double -> Bool
isRangeN k = k >= 0.005 && k < (2.0/3.0)
{-# INLINE isRangeN #-}

